/** 
 * 
 * Copyright 2005 LogicBlaze, Inc. http://www.logicblaze.com
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.servicemix.jbi.jaxp;

import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.Source;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.Reader;
import java.io.StringReader;

/**
 * A helper class which provides a JAXP {@link Source} from a String
 * which can be read as many times as required.
 *
 * @version $Revision: 1.1 $
 */
public class StringSource extends StreamSource {
    private String text;

    public StringSource(String text) {
        this.text = text;
    }

    public StringSource(String text, String systemId) {
        this.text = text;
        setSystemId(systemId);
    }

    public InputStream getInputStream() {
        return new ByteArrayInputStream(text.getBytes());
    }

    public Reader getReader() {
        return new StringReader(text);
    }

}
