/** 
 * <a href="http://servicemix.org">ServiceMix: The open source ESB</a> 
 * 
 * Copyright 2005 RAJD Consultancy Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/

package org.servicemix.jbi.nmr.flow;
import java.io.IOException;
import javax.jbi.JBIException;
import org.activemq.util.FactoryFinder;

/**
 * Find a Flow by Name
 * 
 * @version $Revision: 1.1 $
 */
public class FlowProvider {
    private static FactoryFinder finder = new FactoryFinder("META-INF/services/org/servicemix/jbi/nmr/flow/");

    /**
     * Locate a Flow
     * 
     * @param flow
     * @return the Flow
     * @throws JBIException
     */
    public static Flow getFlow(String flow) throws JBIException {
        Object value;
        try {
            value = finder.newInstance(flow);
            if (value != null && value instanceof Flow) {
                return (Flow) value;
            }
            else {
                throw new JBIException("No implementation found for: " + flow);
            }
        }
        catch (IllegalAccessException e) {
            throw new JBIException(e);
        }
        catch (InstantiationException e) {
            throw new JBIException(e);
        }
        catch (IOException e) {
            throw new JBIException(e);
        }
        catch (ClassNotFoundException e) {
            throw new JBIException(e);
        }
    }
}