/** 
 * 
 * Copyright 2005 LogicBlaze, Inc. http://www.logicblaze.com
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.servicemix.jbi.resolver;

import javax.jbi.component.Component;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.jbi.messaging.MessageExchange;

/**
 * Filters out only the endpoints which the component approves for producing. 
 * 
 * @version $Revision: 1.1 $
 */
public class ProducerComponentEndpointFilter implements EndpointFilter {
    private Component component;

    public ProducerComponentEndpointFilter(Component component) {
        this.component = component;
    }

    public boolean evaluate(ServiceEndpoint endpoint, MessageExchange exchange) {
        return component.isExchangeWithProviderOkay(endpoint, exchange);
    }
}
