/** 
 * 
 * Copyright 2005 LogicBlaze, Inc. http://www.logicblaze.com
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.servicemix.components.http;

import org.servicemix.TestSupport;
import org.springframework.context.support.AbstractXmlApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.w3c.dom.Node;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;

/**
 * @version $Revision: 1.1 $
 */
public class HttpTest extends TestSupport {

    protected String quote = "SUNW";

    public void testCurrencyQuotes() throws Exception {
        QName serviceName = new QName("http://servicemix.org/cheese/", "httpSender");
        String file = "request.xml";

        Object answer = requestServiceWithFileRequest(serviceName, file);

        Node node = null;
        if (answer instanceof Node) {
            node = (Node) answer;
        }
        else {
            assertTrue("Shoud return a Source instance: " + answer, answer instanceof Source);
            node = transformer.toDOMNode((Source) answer);
        }

        assertNotNull("Should have found a non-null node!", node);
        System.out.println(transformer.toString(node));

        String text = textValueOfXPath(node, "//Result").trim();

        System.out.println("Found price: " + text);

        assertTrue("price text should not be empty", text.length() > 0);

    }

    protected AbstractXmlApplicationContext createBeanFactory() {
        return new ClassPathXmlApplicationContext("org/servicemix/components/http/example.xml");
    }
}
